Hierholzer’s Algorithm for directed graph
Last Updated :
14 Feb, 2023
Given a directed Eulerian graph, print an Euler circuit. Euler circuit is a path that traverses every edge of a graph, and the path ends on the starting vertex. Examples:
Input : Adjacency list for the below graph
Output : 0 -> 1 -> 2 -> 0
Input : Adjacency list for the below graph
Output : 0 -> 6 -> 4 -> 5 -> 0 -> 1
-> 2 -> 3 -> 4 -> 2 -> 0
Explanation:
In both the cases, we can trace the Euler circuit
by following the edges as indicated in the output.
We have discussed the problem of finding out whether a given graph is Eulerian or not. In this post, an algorithm to print the Eulerian trail or circuit is discussed. The same problem can be solved using Fleury’s Algorithm, however, its complexity is O(E*E). Using Hierholzer’s Algorithm, we can find the circuit/path in O(E), i.e., linear time. Below is the Algorithm: ref ( wiki ). Remember that a directed graph has a Eulerian cycle if the following conditions are true (1) All vertices with nonzero degrees belong to a single strongly connected component. (2) In degree and out-degree of every vertex is the same. The algorithm assumes that the given graph has a Eulerian Circuit.
- Choose any starting vertex v, and follow a trail of edges from that vertex until returning to v. It is not possible to get stuck at any vertex other than v, because indegree and outdegree of every vertex must be same, when the trail enters another vertex w there must be an unused edge leaving w. The tour formed in this way is a closed tour, but may not cover all the vertices and edges of the initial graph.
- As long as there exists a vertex u that belongs to the current tour, but that has adjacent edges not part of the tour, start another trail from u, following unused edges until returning to u, and join the tour formed in this way to the previous tour.
Thus the idea is to keep following unused edges and removing them until we get stuck. Once we get stuck, we backtrack to the nearest vertex in our current path that has unused edges, and we repeat the process until all the edges have been used. We can use another container to maintain the final path. Let’s take an example:
Let the initial directed graph be as below
Let's start our path from 0.
Thus, curr_path = {0} and circuit = {}
Now let's use the edge 0->1
Now, curr_path = {0,1} and circuit = {}
similarly we reach up to 2 and then to 0 again as
Now, curr_path = {0,1,2} and circuit = {}
Then we go to 0, now since 0 haven't got any unused
edge we put 0 in circuit and back track till we find
an edge
We then have curr_path = {0,1,2} and circuit = {0}
Similarly, when we backtrack to 2, we don't find any
unused edge. Hence put 2 in the circuit and backtrack
again.
curr_path = {0,1} and circuit = {0,2}
After reaching 1 we go to through unused edge 1->3 and
then 3->4, 4->1 until all edges have been traversed.
The contents of the two containers look as:
curr_path = {0,1,3,4,1} and circuit = {0,2}
now as all edges have been used, the curr_path is
popped one by one into the circuit.
Finally, we've circuit = {0,2,1,4,3,1,0}
We print the circuit in reverse to obtain the path followed.
i.e., 0->1->3->4->1->1->2->0
Below is the implementation for the above approach:
C++
#include <bits/stdc++.h>
using namespace std;
void printCircuit(vector< vector< int > > adj)
{
unordered_map< int , int > edge_count;
for ( int i=0; i<adj.size(); i++)
{
edge_count[i] = adj[i].size();
}
if (!adj.size())
return ;
stack< int > curr_path;
vector< int > circuit;
curr_path.push(0);
int curr_v = 0;
while (!curr_path.empty())
{
if (edge_count[curr_v])
{
curr_path.push(curr_v);
int next_v = adj[curr_v].back();
edge_count[curr_v]--;
adj[curr_v].pop_back();
curr_v = next_v;
}
else
{
circuit.push_back(curr_v);
curr_v = curr_path.top();
curr_path.pop();
}
}
for ( int i=circuit.size()-1; i>=0; i--)
{
cout << circuit[i];
if (i)
cout<< " -> " ;
}
}
int main()
{
vector< vector< int > > adj1, adj2;
adj1.resize(3);
adj1[0].push_back(1);
adj1[1].push_back(2);
adj1[2].push_back(0);
printCircuit(adj1);
cout << endl;
adj2.resize(7);
adj2[0].push_back(1);
adj2[0].push_back(6);
adj2[1].push_back(2);
adj2[2].push_back(0);
adj2[2].push_back(3);
adj2[3].push_back(4);
adj2[4].push_back(2);
adj2[4].push_back(5);
adj2[5].push_back(0);
adj2[6].push_back(4);
printCircuit(adj2);
return 0;
}
|
Java
import java.util.*;
public class Program {
public static void
PrintCircuit(List<List<Integer> > adj)
{
Map<Integer, Integer> edge_count
= new HashMap<Integer, Integer>();
for ( int i = 0 ; i < adj.size(); i++) {
edge_count.put(i, adj.get(i).size());
}
if (adj.size() == 0 ) {
return ;
}
Stack<Integer> curr_path = new Stack<Integer>();
List<Integer> circuit = new ArrayList<Integer>();
curr_path.push( 0 );
int curr_v = 0 ;
while (curr_path.size() != 0 ) {
if (edge_count.get(curr_v) != 0 ) {
curr_path.push(curr_v);
int next_v = adj.get(curr_v).get(
adj.get(curr_v).size() - 1 );
edge_count.put(curr_v,
edge_count.get(curr_v) - 1 );
adj.get(curr_v).remove(
adj.get(curr_v).size() - 1 );
curr_v = next_v;
}
else {
circuit.add(curr_v);
curr_v = curr_path.pop();
}
}
for ( int i = circuit.size() - 1 ; i >= 0 ; i--) {
System.out.print(circuit.get(i));
if (i != 0 ) {
System.out.print( " -> " );
}
}
}
public static void main(String[] args)
{
List<List<Integer> > adj1
= new ArrayList<List<Integer> >();
List<List<Integer> > adj2
= new ArrayList<List<Integer> >();
adj1.add( new ArrayList<Integer>());
adj1.add( new ArrayList<Integer>());
adj1.add( new ArrayList<Integer>());
adj1.get( 0 ).add( 1 );
adj1.get( 1 ).add( 2 );
adj1.get( 2 ).add( 0 );
PrintCircuit(adj1);
System.out.println();
adj2.add( new ArrayList<Integer>());
adj2.add( new ArrayList<Integer>());
adj2.add( new ArrayList<Integer>());
adj2.add( new ArrayList<Integer>());
adj2.add( new ArrayList<Integer>());
adj2.add( new ArrayList<Integer>());
adj2.add( new ArrayList<Integer>());
adj2.get( 0 ).add( 1 );
adj2.get( 0 ).add( 6 );
adj2.get( 1 ).add( 2 );
adj2.get( 2 ).add( 0 );
adj2.get( 2 ).add( 3 );
adj2.get( 3 ).add( 4 );
adj2.get( 4 ).add( 2 );
adj2.get( 4 ).add( 5 );
adj2.get( 5 ).add( 0 );
adj2.get( 6 ).add( 4 );
PrintCircuit(adj2);
}
}
|
Python3
def printCircuit(adj):
edge_count = dict ()
for i in range ( len (adj)):
edge_count[i] = len (adj[i])
if len (adj) = = 0 :
return
curr_path = []
circuit = []
curr_path.append( 0 )
curr_v = 0
while len (curr_path):
if edge_count[curr_v]:
curr_path.append(curr_v)
next_v = adj[curr_v][ - 1 ]
edge_count[curr_v] - = 1
adj[curr_v].pop()
curr_v = next_v
else :
circuit.append(curr_v)
curr_v = curr_path[ - 1 ]
curr_path.pop()
for i in range ( len (circuit) - 1 , - 1 , - 1 ):
print (circuit[i], end = "")
if i:
print ( " -> " , end = "")
if __name__ = = "__main__" :
adj1 = [ 0 ] * 3
for i in range ( 3 ):
adj1[i] = []
adj1[ 0 ].append( 1 )
adj1[ 1 ].append( 2 )
adj1[ 2 ].append( 0 )
printCircuit(adj1)
print ()
adj2 = [ 0 ] * 7
for i in range ( 7 ):
adj2[i] = []
adj2[ 0 ].append( 1 )
adj2[ 0 ].append( 6 )
adj2[ 1 ].append( 2 )
adj2[ 2 ].append( 0 )
adj2[ 2 ].append( 3 )
adj2[ 3 ].append( 4 )
adj2[ 4 ].append( 2 )
adj2[ 4 ].append( 5 )
adj2[ 5 ].append( 0 )
adj2[ 6 ].append( 4 )
printCircuit(adj2)
print ()
|
C#
using System;
using System.Collections.Generic;
public class Program {
public static void PrintCircuit(List<List< int > > adj)
{
Dictionary< int , int > edge_count
= new Dictionary< int , int >();
for ( int i = 0; i < adj.Count; i++)
{
edge_count[i] = adj[i].Count;
}
if (adj.Count == 0)
return ;
Stack< int > curr_path = new Stack< int >();
List< int > circuit = new List< int >();
curr_path.Push(0);
int curr_v = 0;
while (curr_path.Count != 0)
{
if (edge_count[curr_v] != 0)
{
curr_path.Push(curr_v);
int next_v
= adj[curr_v][adj[curr_v].Count - 1];
edge_count[curr_v]--;
adj[curr_v].RemoveAt(adj[curr_v].Count - 1);
curr_v = next_v;
}
else
{
circuit.Add(curr_v);
curr_v = curr_path.Pop();
}
}
for ( int i = circuit.Count - 1; i >= 0; i--) {
Console.Write(circuit[i]);
if (i != 0)
Console.Write( " -> " );
}
}
public static void Main()
{
List<List< int > > adj1 = new List<List< int > >();
List<List< int > > adj2 = new List<List< int > >();
adj1.Add( new List< int >());
adj1.Add( new List< int >());
adj1.Add( new List< int >());
adj1[0].Add(1);
adj1[1].Add(2);
adj1[2].Add(0);
PrintCircuit(adj1);
Console.WriteLine();
adj2.Add( new List< int >());
adj2.Add( new List< int >());
adj2.Add( new List< int >());
adj2.Add( new List< int >());
adj2.Add( new List< int >());
adj2.Add( new List< int >());
adj2.Add( new List< int >());
adj2[0].Add(1);
adj2[0].Add(6);
adj2[1].Add(2);
adj2[2].Add(0);
adj2[2].Add(3);
adj2[3].Add(4);
adj2[4].Add(2);
adj2[4].Add(5);
adj2[5].Add(0);
adj2[6].Add(4);
PrintCircuit(adj2);
}
}
|
Javascript
function printCircuit(adj) {
const edge_count = new Map();
for (let i = 0; i < adj.length; i++) {
edge_count.set(i, adj[i].length);
}
if (!adj.length) return ;
const curr_path = [];
const circuit = [];
curr_path.push(0);
let curr_v = 0;
while (curr_path.length) {
if (edge_count.get(curr_v)) {
curr_path.push(curr_v);
const next_v = adj[curr_v][adj[curr_v].length - 1];
edge_count.set(curr_v, edge_count.get(curr_v) - 1);
adj[curr_v].pop();
curr_v = next_v;
} else {
circuit.push(curr_v);
curr_v = curr_path[curr_path.length - 1];
curr_path.pop();
}
}
for (let i = circuit.length - 1; i >= 0; i--) {
console.log(circuit[i]);
if (i) console.log( " -> " );
}
}
const adj1 = [[1], [2], [0]];
printCircuit(adj1);
console.log();
const adj2 = [ [1, 6],
[2],
[0, 3],
[4],
[2, 5],
[0],
[4]
];
printCircuit(adj2);
|
Output:
0 -> 1 -> 2 -> 0
0 -> 6 -> 4 -> 5 -> 0 -> 1 -> 2 -> 3 -> 4 -> 2 -> 0
Time complexity : O(V+E), where V is the number of vertices in the graph and E is the number of edges. This is because the code uses a stack to store the vertices and the stack operations push and pop have a time complexity of O(1).
Space complexity : O(V+E), as the code uses a stack to store the vertices and a vector to store the circuit, both of which take up O(V) space. Additionally, the code also uses an unordered_map to store the count of edges for each vertex, which takes up O(E) space.
Alternate Implementation: Below are the improvements made from the above code
The above code kept a count of the number of edges for every vertex. This is unnecessary since we are already maintaining the adjacency list. We simply deleted the creation of edge_count array. In the algorithm we replaced `if edge_count[current_v]` with `if adj[current_v]`
The above code pushes the initial node twice to the stack. Though the way he coded the result is correct, this approach is confusing and inefficient. We eliminated this by appending the next vertex to the stack, instead of the current one.
In the main part, where the author tests the algorithm, the initialization of the adjacency lists `adj1` and `adj2`were a little weird. That potion is also improved.
C++
#include <bits/stdc++.h>
using namespace std;
void printCircuit(vector< int > adj[], int n)
{
if (n == 0)
return ;
vector< int > curr_path;
curr_path.push_back(0);
vector< int > circuit;
while (curr_path.size() > 0) {
int curr_v = curr_path[curr_path.size() - 1];
if (adj[curr_v].size() > 0) {
int next_v = adj[curr_v].back();
adj[curr_v].pop_back();
curr_path.push_back(next_v);
}
else {
circuit.push_back(curr_path.back());
curr_path.pop_back();
}
}
for ( int i = circuit.size() - 1; i >= 0; i--) {
cout << circuit[i];
if (i)
cout << " -> " ;
}
}
int main()
{
int n1 = 3;
vector< int > adj1[n1];
adj1[0].push_back(1);
adj1[1].push_back(2);
adj1[2].push_back(0);
printCircuit(adj1, n1);
cout << endl;
int n2 = 7;
vector< int > adj2[n2];
adj2[0].push_back(1);
adj2[0].push_back(6);
adj2[1].push_back(2);
adj2[2].push_back(0);
adj2[2].push_back(3);
adj2[3].push_back(4);
adj2[4].push_back(2);
adj2[4].push_back(5);
adj2[5].push_back(0);
adj2[6].push_back(4);
printCircuit(adj2, n2);
cout << endl;
return 0;
}
|
Java
import java.util.*;
public class Program {
public static void
PrintCircuit(List<List<Integer> > adj)
{
Map<Integer, Integer> edge_count
= new HashMap<Integer, Integer>();
for ( int i = 0 ; i < adj.size(); i++)
{
edge_count.put(i, adj.get(i).size());
}
if (adj.size() == 0 ) {
return ;
}
Stack<Integer> curr_path = new Stack<Integer>();
List<Integer> circuit = new ArrayList<Integer>();
curr_path.push( 0 );
int curr_v = 0 ;
while (curr_path.size() != 0 ) {
if (edge_count.get(curr_v) != 0 ) {
curr_path.push(curr_v);
int next_v = adj.get(curr_v).get(
adj.get(curr_v).size() - 1 );
edge_count.put(curr_v,
edge_count.get(curr_v) - 1 );
adj.get(curr_v).remove(
adj.get(curr_v).size() - 1 );
curr_v = next_v;
}
else {
circuit.add(curr_v);
curr_v = curr_path.pop();
}
}
for ( int i = circuit.size() - 1 ; i >= 0 ; i--) {
System.out.print(circuit.get(i));
if (i != 0 ) {
System.out.print( " -> " );
}
}
}
public static void main(String[] args)
{
List<List<Integer> > adj1
= new ArrayList<List<Integer> >();
List<List<Integer> > adj2
= new ArrayList<List<Integer> >();
adj1.add( new ArrayList<Integer>());
adj1.add( new ArrayList<Integer>());
adj1.add( new ArrayList<Integer>());
adj1.get( 0 ).add( 1 );
adj1.get( 1 ).add( 2 );
adj1.get( 2 ).add( 0 );
PrintCircuit(adj1);
System.out.println();
adj2.add( new ArrayList<Integer>());
adj2.add( new ArrayList<Integer>());
adj2.add( new ArrayList<Integer>());
adj2.add( new ArrayList<Integer>());
adj2.add( new ArrayList<Integer>());
adj2.add( new ArrayList<Integer>());
adj2.add( new ArrayList<Integer>());
adj2.get( 0 ).add( 1 );
adj2.get( 0 ).add( 6 );
adj2.get( 1 ).add( 2 );
adj2.get( 2 ).add( 0 );
adj2.get( 2 ).add( 3 );
adj2.get( 3 ).add( 4 );
adj2.get( 4 ).add( 2 );
adj2.get( 4 ).add( 5 );
adj2.get( 5 ).add( 0 );
adj2.get( 6 ).add( 4 );
PrintCircuit(adj2);
}
}
|
Python3
def printCircuit(adj):
if len (adj) = = 0 :
return
curr_path = [ 0 ]
circuit = []
while curr_path:
curr_v = curr_path[ - 1 ]
if adj[curr_v]:
next_v = adj[curr_v].pop()
curr_path.append(next_v)
else :
circuit.append(curr_path.pop())
for i in range ( len (circuit) - 1 , - 1 , - 1 ):
print (circuit[i], end = "")
if i:
print ( " -> " , end = "")
if __name__ = = "__main__" :
adj1 = [[] for _ in range ( 3 )]
adj1[ 0 ].append( 1 )
adj1[ 1 ].append( 2 )
adj1[ 2 ].append( 0 )
printCircuit(adj1)
print ()
adj2 = [[] for _ in range ( 7 )]
adj2[ 0 ].append( 1 )
adj2[ 0 ].append( 6 )
adj2[ 1 ].append( 2 )
adj2[ 2 ].append( 0 )
adj2[ 2 ].append( 3 )
adj2[ 3 ].append( 4 )
adj2[ 4 ].append( 2 )
adj2[ 4 ].append( 5 )
adj2[ 5 ].append( 0 )
adj2[ 6 ].append( 4 )
printCircuit(adj2)
print ()
|
C#
using System;
using System.Collections.Generic;
public class Program {
public static void PrintCircuit(List<List< int > > adj)
{
Dictionary< int , int > edge_count
= new Dictionary< int , int >();
for ( int i = 0; i < adj.Count; i++)
{
edge_count[i] = adj[i].Count;
}
if (adj.Count == 0)
return ;
Stack< int > curr_path = new Stack< int >();
List< int > circuit = new List< int >();
curr_path.Push(0);
int curr_v = 0;
while (curr_path.Count != 0)
{
if (edge_count[curr_v] != 0)
{
curr_path.Push(curr_v);
int next_v
= adj[curr_v][adj[curr_v].Count - 1];
edge_count[curr_v]--;
adj[curr_v].RemoveAt(adj[curr_v].Count - 1);
curr_v = next_v;
}
else
{
circuit.Add(curr_v);
curr_v = curr_path.Pop();
}
}
for ( int i = circuit.Count - 1; i >= 0; i--) {
Console.Write(circuit[i]);
if (i != 0)
Console.Write( " -> " );
}
}
public static void Main()
{
List<List< int > > adj1 = new List<List< int > >();
List<List< int > > adj2 = new List<List< int > >();
adj1.Add( new List< int >());
adj1.Add( new List< int >());
adj1.Add( new List< int >());
adj1[0].Add(1);
adj1[1].Add(2);
adj1[2].Add(0);
PrintCircuit(adj1);
Console.WriteLine();
adj2.Add( new List< int >());
adj2.Add( new List< int >());
adj2.Add( new List< int >());
adj2.Add( new List< int >());
adj2.Add( new List< int >());
adj2.Add( new List< int >());
adj2.Add( new List< int >());
adj2[0].Add(1);
adj2[0].Add(6);
adj2[1].Add(2);
adj2[2].Add(0);
adj2[2].Add(3);
adj2[3].Add(4);
adj2[4].Add(2);
adj2[4].Add(5);
adj2[5].Add(0);
adj2[6].Add(4);
PrintCircuit(adj2);
}
}
|
Javascript
function printCircuit(adj, n)
{
if (n == 0) return ;
let curr_path = new Array();
curr_path.push(0);
let circuit = new Array();
while (curr_path.length > 0) {
let curr_v = curr_path[curr_path.length - 1];
if (adj[curr_v].length > 0) {
let next_v = adj[curr_v][adj[curr_v].length - 1];
adj[curr_v].pop();
curr_path.push(next_v);
}
else {
circuit.push(curr_path[curr_path.length - 1]);
curr_path.pop();
}
}
for (let i = circuit.length - 1; i >= 0; i--) {
document.write(circuit[i]);
if (i) document.write( " -> " );
}
document.write( "<br>" );
}
let n1 = 3;
let adj1 = Array.from(Array(n1), () => new Array());
adj1[0].push(1);
adj1[1].push(2);
adj1[2].push(0);
printCircuit(adj1, n1);
let n2 = 7;
let adj2 = Array.from(Array(n2), () => new Array());
adj2[0].push(1);
adj2[0].push(6);
adj2[1].push(2);
adj2[2].push(0);
adj2[2].push(3);
adj2[3].push(4);
adj2[4].push(2);
adj2[4].push(5);
adj2[5].push(0);
adj2[6].push(4);
printCircuit(adj2, n2);
|
Output:
0 -> 1 -> 2 -> 0
0 -> 6 -> 4 -> 5 -> 0 -> 1 -> 2 -> 3 -> 4 -> 2 -> 0
Time Complexity : O(V + E), where V is the number of vertices and E is the number of edges in the graph. The reason for this is because the algorithm performs a depth-first search (DFS) and visits each vertex and each edge exactly once. So, for each vertex, it takes O(1) time to visit it and for each edge, it takes O(1) time to traverse it.
Space complexity : O(V + E), as the algorithm uses a stack to store the current path and a list to store the final circuit. The maximum size of the stack can be V + E at worst, so the space complexity is O(V + E).
The article contains also inputs from Nitish Kumar.
Please Login to comment...